
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *
from stateimagelibrary import *
import random
from time import *
from meter import *
from rng import *
from random import *

class Centaur1(Gameobject):
    "Centaur"
    def __init__(self,xx,yy,aiengine):
	Gameobject.__init__(self, xx, yy)
        self.w = 48
        self.h = 48

        self.aiengine = aiengine

        self.hitpoints = 20
        self.meter = Meter()
        self.meter.setmax(self.hitpoints)        
	self.stimlibdown = Stateimagelibrary()	
	self.stimlibup = Stateimagelibrary()	
        image = pygame.image.load('./pics/centaur1-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibup.addpicture(image)	
        
	image = pygame.image.load('./pics/centaur1-64x64.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlibdown.addpicture(image)  

	self.talkcounter = 0
	self.direction = "down"

    def draw(self, screen, room):
	#if (self.direction == "down"):
        self.stimlibdown.draw(screen, self.x+room.relativex,self.y+room.relativey)
        if self.battlemode:
            self.meter.drawat(screen,self.x+room.relativex,self.y+room.relativey)
	#elif (self.direction == "up"):
        #    self.stimlibup.draw(screen, self.x+room.relativex,self.y+room.relativey)
	    
    def fight(self,room,player):
        if self.battlemode:
            self.aiengine.overallattack()
        #o = player.collidewithenemyweapon(room,self)
        #if o:
        # NOTE: Longbow shoots from a distance
            player.hitwithenemyweapon(RNG().rolllongbow())
            
    def update(self,room,player):
        # NOTE: 300 pixel distance maximum for longbow shooting
        if self.battlemode:
            if player.x-300 < self.x:
                self.x -= 10
            if player.x+300 > self.x:
                self.x += 10
            if player.y-300 < self.y:
                self.y -= 10
            if player.y+300 > self.y:
                self.y += 10
            self.fight(room, player)
            
        r = randint(0,80)
        if r == 0:
            self.direction = "left"
        elif r == 1:
            self.direction = "right"
        elif r == 2:
            self.direction = "up"
        elif r == 3:
            self.direction = "down"
	
	if ( self.collideobjectXY(room)): 
	    if (self.direction == "down"):
	        self.y -=2
	        self.direction = "up" 
	    elif (self.direction == "up"):
	        self.y +=2
	        self.direction = "down"

	if (self.direction == "up"):
	        self.y -=1 
	elif (self.direction == "down"):
	        self.y +=1
	elif (self.direction == "right"):
	        self.x +=1
	elif (self.direction == "left"):
	        self.x -=1

    def collide(self, room, player):
        # FIX BUG
        #print 'centaur x=%d y=%d player x=%d y=%d' % (self.x,self.y,player.x-room.relativex,player.y)
	if (player.x-room.relativex > self.x  and 
	player.x-room.relativex < self.x+self.w and 
	player.y-room.relativey > self.y and 
	player.y-room.relativey < self.y + self.h):
	    #print "collision with Centaur!"
	    return 2 
	else:
	    return 0 ## for game self.talker

##    def hitwithweapon(self,damage):
##	if damage > 0:
##            print 'enemy is hit!'
##        self.hitpoints -= damage
##        # FIXME in all enemies
##        self.meter.index -= damage


    def talk(self, screen,font):
        if self.talkcounter == 0:
            return
 
        pygame.key.set_repeat(1000,1000)
        
        talkover = 0
        while talkover == 0:
            pygame.display.update()
            if self.talkcounter == 1:
                screen.blit(font.render("You are in Centaur Glade.", 6, (255,255,255)), (10,100))
                #sleep(3)
            elif self.talkcounter == 2:
                screen.blit(font.render("I am Colin.", 6, (255,255,255)), (10,120))
                #sleep(3)
            elif self.talkcounter == 3:
                pygame.key.set_repeat(1,1)
                self.talkcounter = 0
                talkover = 1
            for event in pygame.event.get():
                if event.type == QUIT:
                    return
                elif event.type == KEYDOWN:
                    if event.key == K_z:
                        talkover = 1
                        self.talkcounter = 0
                        pygame.key.set_repeat(1,1)
                    if event.key == K_x:
                        self.talkcounter += 1
                
