
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from maproom import *
from tree import *
from tree2 import *
from dungeonentrance1 import *
from dungeonkey1 import *
from maproomdungeon import *
from maproomdungeonnorthwall import *
from goblin1 import *
from goblin2 import *
from goblin3 import *
from butterfly2 import *
from centaur1 import *
from tilebox import *
from snake1 import *
from snake2 import *
from rubysword import *
from beholder import *
from beholderbat import *

class Maproom1(MaproomDungeon):
    "Room with a (big) map"
    def __init__(self,x,y,aiengine):
        MaproomDungeon.__init__(self,x,y)
        self.background = pygame.image.load('./pics/room-bg1.bmp').convert()
        ###self.northwall1 = Tilebox(1,1,60,48,16,1,'./pics/walldungeonnorth2-beholderglass-60x48.bmp')
        self.northwall1 = Tilebox(1,1,60,48,13,1,'./pics/walldungeonnorth1-60x48.bmp')
        self.southwall1 = Tilebox(1,200,30,48,13,1,'./pics/walldungeonsouth1-30x48.bmp')
        self.westwall1 = Tilebox(360,200,48,60,1,10,'./pics/walldungeonwest1-48x60.bmp')
        self.eastwall1 = Tilebox(775,1,48,60,1,14,'./pics/walldungeoneast1-48x60.bmp')
        #self.tileboxes.append(self.northwall1)
        #self.tileboxes.append(self.westwall1)
        #self.tileboxes.append(self.eastwall1)
        #self.tileboxes.append(self.southwall1)


        #FIX	self.gameobjects.append(Dungeonentrance1(0,0))
##	self.gameobjects.append(Tree2(10,100))
##	self.gameobjects.append(Tree2(100,100))
##	self.gameobjects.append(Tree2(200,120))
        self.centaur1 = Centaur1(50,230,aiengine)
        self.gameobjects.append(self.centaur1)
        self.centaur2 = Centaur1(440,230,aiengine)
        self.gameobjects.append(self.centaur2)

        self.aiengine = aiengine
        self.aiengine.add(self.centaur1)
        self.aiengine.add(self.centaur2)

        self.gameobjects.append(Butterfly2(100,100))
        self.gameobjects.append(Butterfly2(300,180))
        self.gameobjects.append(Butterfly2(500,120))
        
        self.gameobjects.append(Dungeonkey1(100,120))
##        b = Box(650,0,150,300)
##        b.setimage('./pics/knightdungeon1-150x350.bmp',0,0,0)
##        self.gameobjects.append(b)
##        # upper crevasses
##        self.gameobjects.append(Box(0,0,375,75))
##        self.gameobjects.append(Box(375,0,100,100))
##        self.gameobjects.append(Box(475,0,100,125))
##        self.gameobjects.append(Box(500,0,120,180))
##        self.gameobjects.append(Box(600,0,50,160))
##        self.gameobjects.append(Box(650,0,25,75))
##        self.gameobjects.append(Box(675,0,75,40))
##        self.gameobjects.append(Box(750,0,50,40))
##        # lower crevasses
##        self.gameobjects.append(Box(500,220,120,400))
##        self.gameobjects.append(Box(0,400,800,100))
        #self.addnorthwall(0,0)
 
    def draw(self,screen,player):
        # draw bg
        screen.blit(self.background, (0+self.relativex, 0+self.relativey))
        # draw walls
        # draw automove
        MaproomDungeon.draw(self,screen)
        for t in self.tileboxes:
            t.draw(screen,self.relativex,self.relativey)
        #self.southwall1.draw(screen,self.relativex,self.relativey)
        # draw gameobjects
        for i in self.gameobjects:
	    if i != None:
		i.update(self,player)
		i.draw(screen,self)
	
    def pickup(self, player):###FIX for each room
	###print 'pickup1'
        for o in self.gameobjects:
            if (o and o.collide(self, player)):##FIX o.colidepickup
                id = o.pickup(self)
                self.dungeonkey1 = 1
		print 'pickup'
		return id
        return 0
    

    def isroomdownexit(self):
	if self.relativex  < -250 and self.relativex > -650 and self.relativey < -650:
		return 1
	return 0

    def setxyfromdown(self):
        self.relativex = 0
	self.relativey = 0

    def exit(self, game):
	if self.isroomdownexit():
		self.setxyfromdown()
		return 2
	return 0 

    def talkto(self):#FIXME needs font
            print "talk to in maproom 6"
            ## return self.koboldwiz
            self.centaur1.talkcounter = 1
            return (self.centaur1,self.centaur2)
 
    def collidesword(self,player):
        for i in self.gameobjects:
	    if i!= None:
	    	id = i.collidewithsword(self,player)
		#self.relativex = self.prevx
		#self.relativey = self.prevy
		return i ## NOTE : returns collided entity (single)
	return None


    def removeobject(self, o):
        for i in range(0,len(self.gameobjects)):
            if self.gameobjects[i] == o:
                self.gameobjects[i] = None
