
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from stateimagelibrary import *
from playerbase import *
from rng import *
from broadsword import *
from rubysword import *

class Player(PlayerBase):
    "Player"
    def __init__(self,PLAYERRACE,PLAYERCLASS,heartmeter):
        PlayerBase.__init__(self,PLAYERRACE,PLAYERCLASS,heartmeter)
        
        self.stimlib = Stateimagelibrary()
        if PLAYERRACE == PlayerBase.ELF:
            image = pygame.image.load('./pics/player1-48x48.bmp').convert()
        if PLAYERRACE == PlayerBase.CENTAUR:
            image = pygame.image.load('./pics/centaur1-64x64.bmp').convert()
        if PLAYERRACE == PlayerBase.FAIRY:
            image = pygame.image.load('./pics/fairy1-48x48.bmp').convert()
        if PLAYERRACE == PlayerBase.GNOME:
            if PLAYERCLASS == PlayerBase.MAGICUSER:
                image = pygame.image.load('./pics/gnomemagicuser1-48x48.bmp').convert()
            else:
                image = pygame.image.load('./pics/gnome1-48x48.bmp').convert()
        image.set_colorkey((0,0,0)) 
	self.stimlib.addpicture(image)		

        self.stimlibfight = Stateimagelibrary()
        if PLAYERRACE == PlayerBase.ELF:
            image = pygame.image.load('./pics/player1-48x48.bmp').convert()
        if PLAYERRACE == PlayerBase.CENTAUR:
            image = pygame.image.load('./pics/centaur1-64x64.bmp').convert()
        if PLAYERRACE == PlayerBase.FAIRY:
            image = pygame.image.load('./pics/fairy1-48x48.bmp').convert()
        if PLAYERRACE == PlayerBase.GNOME:
            image = pygame.image.load('./pics/gnome1-48x48.bmp').convert()
        ##image = pygame.image.load('./pics/playerfight1-48x48.bmp').convert()
        image.set_colorkey((0,0,0))
        self.stimlibfight.addpicture(image)	

        self.hitpoints = 50
       	self.sword = BroadSword(0,0)
 
    def askclass(self):
        return ""

    def askrace(self):
        return ""

    def askpicture(self):
        return ''

    def collidewithenemyweapon(self,room,o):
        if o.collide(room,self):
		return self ## NOTE : returns collided entity (single)
		
	return None

    def hitwithenemyweapon(self,damage):
	if damage > 0:
		print 'player is hit!'
        self.hitpoints -= damage

    def pickup(self,room):
        n = room.pickup(self)
	return n

    def fight(self,room):
        self.fightcounter = 1
        o = room.collidesword(self)
        if o:
            o.hitwithweapon(self.sword.roll())
       
    def setrubysword(self):
	self.sword = RubySword(0,0)
