
# Copyright (C) Johan Ceuppens 2010
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from stateimagelibrary import *
##from playerkatta import *
from playerfighter import *
from playermagicuser import *
from playerpriest import *
from playerpaladin import *
##from playermagicuser import *
##from playerelf import *
##from playerdrow import *
from playerfairy import *
from playerelf import *
from playercentaur import *	
from playergnome import *

class PlayerBase:
    def __init__(self):
        1

class PlayerBase(PlayerBase,PlayerBase):
    "Player"

    PlayerBase.FIGHTER,PlayerBase.MAGICUSER,PlayerBase.PRIEST,PlayerBase.PALADIN = xrange(4)#,PlayerBase.MAGICUSER,PlayerBase.THIEF = xrange(3)
    #PlayerBase.HUMAN,PlayerBase.KATTA,PlayerBase.ELF,PlayerBase.DROW = xrange(4)#,PlayerBase.HUMAN,PlayerBase.DROW = xrange(3)
    PlayerBase.ELF,PlayerBase.CENTAUR,PlayerBase.FAIRY,PlayerBase.GNOME = xrange(4)#,PlayerBase.HUMAN,PlayerBase.DROW = xrange(3)
    
    def __init__(self,PLAYERRACE,PLAYERCLASS,heartmeter):
        classByType = {
                PlayerBase.ELF : PlayerElf,
                PlayerBase.CENTAUR : PlayerCentaur,
                PlayerBase.FAIRY : PlayerFairy,
                PlayerBase.GNOME : PlayerGnome,
        }
        classByType2 = {
                PlayerBase.FIGHTER : PlayerFighter,
                PlayerBase.MAGICUSER : PlayerMagicUser,
                PlayerBase.PRIEST : PlayerPriest,
                PlayerBase.PALADIN : PlayerPaladin,
        }
	self.heartmeter = heartmeter

        self.x = 320 
        self.y = 200 
        self.w = 48 
        self.h = 48
		
        self.highlightbase = 0
        
        self.fightcounter = 0

        self.race = classByType[PLAYERRACE]()
        self.klass = classByType2[PLAYERCLASS]()
        self.inventoryrow1 = []
        self.inventoryrow2 = []
        if self.race.inventoryrow1:
            for o in self.race.inventoryrow1:
                self.inventoryrow1.append(o)
        if self.race.inventoryrow2:
            for o in self.race.inventoryrow2:
                self.inventoryrow2.append(o)
        if self.klass.inventoryrow1:
            for o in self.klass.inventoryrow1:
                self.inventoryrow1.append(o)
        if self.klass.inventoryrow2:
            for o in self.klass.inventoryrow2:
                self.inventoryrow2.append(o)

        self.highlightimage = pygame.image.load('./pics/highlightbase1.bmp').convert()
        self.highlightimage.set_colorkey((0,0,0))

        # clicked mouse button released for moving
        self.mousex = self.x
        self.mousey = self.y
        
    def drawstatic(self, screen):
        # NOTE
        if self.highlightbase:            
            #screen.blit(self.highlightimage, (self.x+room.relativex,self.y+room.relativey))
            screen.blit(self.highlightimage, (self.x-5,self.y+2*self.h/3))

        if self.fightcounter > 0:
            self.fightcounter += 1
            if self.fightcounter > 10:
                self.fightcounter = 0
            self.stimlibfight.draw(screen,self.x,self.y)
            return
	self.stimlib.drawstatic(screen,self.x,self.y,0)
	
    def draw(self, screen):
        # NOTE
        
        if self.highlightbase:            
            screen.blit(self.highlightimage, (self.x-5,self.y*2/3))

        if self.fightcounter > 0:
            self.fightcounter += 1
            if self.fightcounter > 10:
                self.fightcounter = 0
            self.stimlibfight.draw(screen,self.x,self.y)
            return
        self.stimlib.draw(screen, self.x,self.y)

    def fight(self,room):
        self.fightcounter = 1
##        self.x -= 30
##        self.y -= 30
##        self.w += 30
##        self.h += 30
        
        o = room.collidesword(room,self)
        
        if o:
            print 'hit!'
            room.hitwithsword(o)
##        self.x += 30
##        self.y += 30
##        self.w -= 30
##        self.h -= 30
##        
    def hit(self):
	self.heartmeter.index -= 1 
	if self.heartmeter.index <= 0:
		return 0 #FIXME1 FIX for gameover when collision with enemies 
	else:
		return 0	

    def highlight(self):
        self.highlightbase = 1

    def unhighlight(self):
        self.highlightbase = 0

    #FIXME URGENT
    def circumvent(self,room):
         if room.direction == "north":
             if self.mousex <= player.x-room.relativex:
                 room.direction = "west"
             elif self.mousex > player.x-room.relativex:
                 room.direction = "east"

