
# Copyright (C) Johan Ceuppens 2010 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *

class Selector:
    def __init__(self,screen):
        self.blankimage = pygame.image.load('./pics/blank.bmp').convert()
        self.font = pygame.font.SysFont("Vera", 48)
        self.font2 = pygame.font.SysFont("Vera", 28)
        
class RaceSelector(Selector):
    def __init__(self,screen):
        Selector.__init__(self, screen)
        class SelectorImg:
            def __init__(self,x,y,text,imgfn):
                self.x = x
                self.y = y
                self.text = text               
                self.image = Selector(screen).font.render(text,6,(0,0,200))
                self.image2 = Selector(screen).font.render(text,6,(0,200,0))
                self.img = pygame.image.load(imgfn)
                self.img.set_colorkey((0,0,0)) 
    
            def draw(self,double = 0):
                screen.blit(Selector(None).font2.render('Race ?', 6, (0,0,200)), (10,20))
                screen.blit(self.image, (self.x,self.y))
                screen.blit(self.image2, (self.x+2,self.y+2))
                screen.blit(self.img, (self.x+200,self.y))
                
        SelectorImg(100,100,"Elf","./pics/player1-48x48.bmp").draw()
        SelectorImg(100,200,"Centaur","./pics/centaur1-64x64.bmp").draw()
        SelectorImg(100,300,"Fairy","./pics/fairy1-48x48.bmp").draw()
        SelectorImg(100,400,"Gnome","./pics/gnome1-48x48.bmp").draw()
        
        def domouse(self):
            mousepos = pygame.mouse.get_pos()
            mousex = mousepos[0]
            mousey = mousepos[1]


class ClassSelector(Selector):
    def __init__(self,screen):
        Selector.__init__(self, screen)
        class SelectorImg:
            def __init__(self,x,y,text,imgfn):
                self.x = x
                self.y = y
                self.text = text               
                self.image = Selector(screen).font.render(text,6,(0,0,200))
                self.image2 = Selector(screen).font.render(text,6,(0,200,0))
                #self.img = pygame.image.load(imgfn)
                #self.img.set_colorkey((0,0,0)) 
    
            def draw(self,double = 0):
                
                screen.blit(Selector(None).font2.render('Class ?', 6, (0,0,200)), (10,20))
                screen.blit(self.image, (self.x,self.y))
                screen.blit(self.image2, (self.x+2,self.y+2))
                #screen.blit(self.img, (self.x+200,self.y))
                
        SelectorImg(100,100,"Fighter","./pics/player1-48x48.bmp").draw()
        SelectorImg(100,200,"Magic User","./pics/fairy1-48x48.bmp").draw()
        SelectorImg(100,300,"Priest","./pics/centaur1-64x64.bmp").draw()
        SelectorImg(100,400,"Paladin","./pics/fairy1-48x48.bmp").draw()
        
        def domouse(self):
            mousepos = pygame.mouse.get_pos()
            mousex = mousepos[0]
            mousey = mousepos[1]

class DietySelector(Selector):
    def __init__(self,screen):
        Selector.__init__(self, screen)
        class SelectorImg:
            def __init__(self,x,y,text,imgfn):
                self.x = x
                self.y = y
                self.text = text               
                self.image = Selector(screen).font.render(text,6,(0,0,200))
                self.image2 = Selector(screen).font.render(text,6,(0,200,0))
                #self.img = pygame.image.load(imgfn)
                #self.img.set_colorkey((0,0,0)) 
    
            def draw(self,double = 0):
                
                screen.blit(Selector(None).font2.render('Diety ?', 6, (0,0,200)), (10,20))
                screen.blit(self.image, (self.x,self.y))
                screen.blit(self.image2, (self.x+2,self.y+2))
                #screen.blit(self.img, (self.x+200,self.y))
                
        SelectorImg(100,100,"Skerrit","./pics/player1-48x48.bmp").draw()
        SelectorImg(100,200,"Ehlonna","./pics/fairy1-48x48.bmp").draw()
        SelectorImg(100,300,"Goldenroost","./pics/centaur1-64x64.bmp").draw()
        
        def domouse(self):
            mousepos = pygame.mouse.get_pos()
            mousex = mousepos[0]
            mousey = mousepos[1]

class AnotherPCSelector(Selector):
    def __init__(self,screen):
        Selector.__init__(self, screen)
        class SelectorImg:
            def __init__(self,x,y,text,imgfn):
                self.x = x
                self.y = y
                self.text = text               
                self.image = Selector(screen).font.render(text,6,(0,0,200))
                self.image2 = Selector(screen).font.render(text,6,(0,200,0))
                #self.img = pygame.image.load(imgfn)
                #self.img.set_colorkey((0,0,0)) 
    
            def draw(self,double = 0):
                
                screen.blit(Selector(None).font2.render('Create an extra character ?', 6, (0,0,200)), (10,20))
                screen.blit(self.image, (self.x,self.y))
                screen.blit(self.image2, (self.x+2,self.y+2))
                #screen.blit(self.img, (self.x+200,self.y))
                
        SelectorImg(100,100,"Yes","./pics/player1-48x48.bmp").draw()
        SelectorImg(100,200,"No","./pics/fairy1-48x48.bmp").draw()
        
        def domouse(self):
            mousepos = pygame.mouse.get_pos()
            mousex = mousepos[0]
            mousey = mousepos[1]
        
class PlayerMaker:
    "Class and Race"
    def __init__(self):
        self.background = pygame.image.load('./pics/blank.bmp').convert()
        self.klass = ""
        self.race = ""
  
    def draw(self):
        1

    def start(self,screen):
        self.blankimage = pygame.image.load('./pics/blank.bmp').convert()
        screen.blit(self.blankimage, (0,0))
        flag = 1
        while flag:
                self.draw()
                rs = RaceSelector(screen)
                pygame.display.update()
                for event in pygame.event.get():
                    if event.type == QUIT:
                        break
                    if event.type == pygame.MOUSEBUTTONDOWN:
                        position = pygame.mouse.get_pos()
                        mousex = position[0]
                        mousey = position[1]
                        
                        if mousex > 100 and mousex < 200 and mousey > 100 and mousey < 200:
                            self.race = "Elf"    
                            self.klass = "Fighter"
                            flag = 0
                        elif mousex > 100 and mousex < 200 and mousey > 200 and mousey < 300:
                            self.race = "Centaur"    
                            self.klass = "Fighter"
                            flag = 0
                        elif mousex > 100 and mousex < 200 and mousey > 300 and mousey < 400:
                            self.race = "Fairy"    
                            self.klass = "Fighter"
                            flag = 0

                        elif mousex > 100 and mousex < 200 and mousey > 400 and mousey < 500:
                            self.race = "Gnome"    
                            self.klass = "Fighter"
                            flag = 0
        screen.blit(self.blankimage, (0,0))
        flag = 1
        while flag:
                self.draw()
                rs = ClassSelector(screen)
                pygame.display.update()
                for event in pygame.event.get():
                    if event.type == QUIT:
                        break
                    if event.type == pygame.MOUSEBUTTONDOWN:
                        position = pygame.mouse.get_pos()
                        mousex = position[0]
                        mousey = position[1]
                        
                        if mousex > 100 and mousex < 200 and mousey > 100 and mousey < 200:
                            self.klass = "Fighter"
                            flag = 0
                        elif mousex > 100 and mousex < 200 and mousey > 200 and mousey < 300:
                            self.klass = "Magic User"
                            flag = 0
                        elif mousex > 100 and mousex < 200 and mousey > 300 and mousey < 400:
                            self.klass = "Priest"
                            self.blankimage = pygame.image.load('./pics/blank.bmp').convert()
                            screen.blit(self.blankimage, (0,0)) 
                            while flag:
                                self.draw()
                                rs = DietySelector(screen)
                                pygame.display.update()
                                for event in pygame.event.get():
                                    if event.type == QUIT:
                                        return
                                    if event.type == pygame.MOUSEBUTTONDOWN:
                                        position = pygame.mouse.get_pos()
                                        mousex = position[0]
                                        mousey = position[1]
                                        
                                        if mousex > 100 and mousex < 200 and mousey > 100 and mousey < 200:
                                            self.diety = "Skerrit"
                                            flag = 0
                                        elif mousex > 100 and mousex < 200 and mousey > 200 and mousey < 300:
                                            self.diety = "Ehlonna"
                                            flag = 0
                                        elif mousex > 100 and mousex < 200 and mousey > 300 and mousey < 400:
                                            self.diety = "Goldenroost"
                                            flag = 0
                            
                        elif mousex > 100 and mousex < 200 and mousey > 400 and mousey < 500:
                            self.klass = "Paladin"
                            flag = 0
        flag = 1
        self.blankimage = pygame.image.load('./pics/blank.bmp').convert()
        screen.blit(self.blankimage, (0,0))
        while flag:
            self.draw()
            rs = AnotherPCSelector(screen)
            pygame.display.update()
            for event in pygame.event.get():
                if event.type == QUIT:
                    return
                if event.type == pygame.MOUSEBUTTONDOWN:
                    position = pygame.mouse.get_pos()
                    mousex = position[0]
                    mousey = position[1]
                    
                    if mousex > 100 and mousex < 200 and mousey > 100 and mousey < 200:
                        return 1 
                    elif mousex > 100 and mousex < 200 and mousey > 200 and mousey < 300:
                        return 0

    def askrace(self):
        return self.race

    def askclass(self):
        return self.klass

    def askdiety(self):
        return self.diety
