
# Copyright (C) Johan Ceuppens 2010 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import pygame
from pygame.locals import *
from gameobject import *
from inventory import *

class Taskbar:
    "Taskbar"
    def __init__(self, screen, font, player, player2):
        self.screen = screen	
        self.font = font
        self.player = player
        self.player2 = player2
        self.background = pygame.image.load('./pics/blank.bmp').convert()
        self.background.set_colorkey((0,0,255)) 
        self.pc = pygame.image.load(player.askpicture()).convert()
        self.swordimage = pygame.image.load('./pics/taskbar-defaultsword1-32x32.bmp').convert()
        self.swordimage.set_colorkey((0,0,255)) 
        self.pcimage = pygame.image.load(player.askpicture()).convert()
        self.pcimage.set_colorkey((0,0,0))
        if player2:
            self.pcimage2 = pygame.image.load(player2.askpicture()).convert()
            self.pcimage2.set_colorkey((0,0,0))
        self.highlightimage = pygame.image.load('./pics/highlightpc1.bmp').convert()
        self.highlightimage.set_colorkey((0,0,0))

        self.highlightpc = 0
        
    def drawlife(self):
	for i in range(0,self.player.hitpoints):
		self.screen.blit(self.lifeimage, (10+i*2,10))

    def highlight(self):
        self.highlightpc = 1

    def setswordimage(self, imagefilename,r,g,b):
        self.swordimage = pygame.image.load(imagefilename).convert()
        self.swordimage.set_colorkey((r,g,b)) 

    def draw(self):
        self.screen.blit(self.background, (0, 400))
##        
##        self.screen.blit(self.pc, (10, 300))
        self.screen.blit(self.font.render(self.player.askrace() + ' ' + self.player.askclass(), 6, (255,255,255)), (0,450))
        if self.player2:
            self.screen.blit(self.font.render(self.player2.askrace() + ' ' + self.player2.askclass(), 6, (255,255,255)), (100,450))
###       	self.drawlife()
        if self.highlightpc:
            self.screen.blit(self.highlightimage, (0,480))
        self.screen.blit(self.pcimage, (0, 400))
        if self.player2:
            self.screen.blit(self.pcimage2, (100, 400))

    def openinventory(self,playerflag,font):
        if playerflag == 1:
            return Inventory(font)
        elif playerflag == 2:
            return Inventory(font)
        else:
            return 0
        
    def domouse(self, player, player2):
        pos = pygame.mouse.get_pos()
        posx = pos[0]
        posy = pos[1]
        if posx > 0 and posx < 640 and posy > 400 and posy < 480:
            print 'click on taskbar'
            if posx > 0 and posx < 100:
                return 1
            elif posx > 100 and posx < 200:
                return 2
        return 0
            
    def setdungeonkey1(self):
        self.setswordimage('./pics/dungeonkey1-36x36.bmp',0,0,255)

    def setrubysword(self):
        self.setswordimage('./pics/taskbar-rubysword1-32x32.bmp',0,0,255)
